@echo off
::---------------------------------------------------------------------------------
:: USAGE: cmd /V:ON /C _.cmd _.keys usb-1394.reg
:: DESCRIPTION:
::   Script to read a file with REG Keys and export them to a Registry file 
::   Occurrences of expanded %systemroot% are replaced with unexpanded %SYSTEMROOT%
::---------------------------------------------------------------------------------

Title=creating usb-1394.reg and USB-1394.inf

setlocal

SET KEYFILE=%1
SET OUTREG=%2
SET LOGFILE=export_regkeys.log

echo KeyFile:  %KEYFILE%
echo OutReg:   %OUTREG%

:: Set SYSROOT = expanded %systemroot% with doubled backslashes
set SYSROOT=%systemroot:\=\\%

echo LOG FILE > %LOGFILE%

::----------------------
:: GET/SET Local Ansi code page (used for Unicode->Ansi conversion)
:: (part from a script by cyrano)
::----------------------

set CodePage=HKLM\SYSTEM\CurrentControlSet\Control\Nls\CodePage
FOR /F "tokens=1-2*" %%a IN ('reg query "%CodePage%" /v "OEMCP"') DO (
set OEMCP=%%c)
FOR /F "tokens=1-2*" %%a IN ('reg query "%CodePage%" /v "ACP"') DO (
set ACP=%%c)

chcp %ACP% >> %LOGFILE%

::----------------------
:: Start with REG export
::----------------------

echo Windows Registry Editor Version 5.00 > %OUTREG%
echo. >> %OUTREG%

:: Read each HKEY line from KEYFILE
for /F "tokens=*" %%i IN (%KEYFILE%) do (
 echo Processing "%%i"
 echo Processing "%%i" >> %LOGFILE%
 
:: REG export it to tmp.reg (Unicode format)
 reg export "%%i" tmp.reg 1>>%LOGFILE% 2>&1

:: Parse  tmp.reg (skipping first two lines), converting from Unicode to Ansi
if not errorlevel 1 FOR /F "skip=2 tokens=*" %%a IN ('type tmp.reg') DO (
 set tmpline=%%a
 echo !tmpline:%SYSROOT%=%%systemroot%%!>> %OUTREG%
)

if not errorlevel 1 echo. >>%OUTREG%
if exist tmp.reg del tmp.reg >> %LOGFILE%
)

:_cleanup
:: Restore normal OEM Codepage
chcp %OEMCP% >> %LOGFILE%

del tmp.reg >> %LOGFILE%
::del export_regkeys.log

endlocal



Title=[ autoHelp ] usb + 1394
MODE CON: COLS=80 LINES=11

cls
echo.
echo.
echo.
ECHO          ͻ
ECHO                                                                      
ECHO                        The plugin is now ready to use.               
ECHO                                                                      
ECHO          ͼ
pause

:_end
